;;; ==============================
;;; :CREATED <Timestamp: #{2010-11-09T15:22:14-05:00Z}#{10452} - by MON>
;;; ==============================

(defvar slime-echo-arglist-function 'slime-show-arglist
  "Symbol naming a function. Used by `slime-echo-arglist' and `slime-space'.")

(make-variable-buffer-local 'slime-echo-arglist-function)
(put 'slime-echo-arglist-function 'permanent-local t)
(set-default 'slime-echo-arglist-function 'slime-show-arglist)

(defcustom *slime-echo-arglist-ignore-function* 'ignore
  "Symbol naming a function to use when `slime-echo-arglist' shouldn't. 
The function will become the default buffer-local-value when
`slime-echo-arglist-toggle' is invoked to override default-value of
`slime-echo-arglist-function'.
The default value is `ignore', which effectively prevents `slime-space' from
verbosely echoing arglists to minibuffer."
  :type  'function
  :group 'slime-ui)

(defun slime-echo-arglist-toggle ()
  (interactive)
  (with-current-buffer (current-buffer)
    (apply slime-message-function
           (concat ;; :NOTE byte-compiler will optimize away this concat.
            "Toggled buffer-local-value `slime-echo-arglist-function'"
            "in buffer: %s, new value is `%S'")
           (list (buffer-name)
                 (if (eq (buffer-local-value 'slime-echo-arglist-function 
                                             (current-buffer))
                         (default-value 'slime-echo-arglist-function))
                     (set (make-local-variable 'slime-echo-arglist-function)
                          *slime-echo-arglist-ignore-function*)
                   (set (make-local-variable 'slime-echo-arglist-function) 
                        (default-value 'slime-echo-arglist-function)))))))

;;; ==============================
;;; EOF
